 member

  INCLUDE('xlsxwriter.inc')

 MAP
     MODULE('libxlsxwriter.dll')
       workbook_new(*CSTRING Filename),LONG,RAW,C,NAME('workbook_new')
       workbook_add_worksheet(LONG workbook,*CSTRING sheetname),LONG,RAW,C,NAME('workbook_add_worksheet')
       workbook_add_format(LONG workbook),LONG,RAW,C,NAME('workbook_add_format')
       workbook_close(LONG workbook),LONG,RAW,C,NAME('workbook_close')

       worksheet_write_number(LONG worksheet,LONG row,LONG col,REAL number,LONG format),LONG,RAW,C,NAME('worksheet_write_number')
       worksheet_write_boolean(LONG worksheet,LONG row,LONG col,SHORT value,LONG format),LONG,RAW,C,NAME('worksheet_write_boolean')
       worksheet_write_string(LONG worksheet,LONG row,LONG col,*CSTRING string,LONG format),LONG,RAW,C,NAME('worksheet_write_string')
       worksheet_write_datetime(LONG worksheet,LONG row,LONG col,*DATETIME datetime,LONG format),LONG,RAW,C,NAME('worksheet_write_datetime')
       worksheet_write_blank(LONG worksheet,LONG row,LONG col,LONG format),LONG,RAW,C,NAME('worksheet_write_blank')
       worksheet_write_url(LONG worksheet,LONG row,LONG col,*CSTRING url,LONG format),LONG,RAW,C,NAME('worksheet_write_url')
       worksheet_write_formula(LONG worksheet,LONG row,LONG col,*CSTRING formula,LONG format),LONG,RAW,C,NAME('worksheet_write_formula')
       worksheet_write_formula_num(LONG worksheet,LONG row,LONG col,*CSTRING formula,LONG format,REAL result),LONG,RAW,C,NAME('worksheet_write_formula_num')
       worksheet_set_row(LONG worksheet,LONG row,REAL height,LONG format),LONG,RAW,C,NAME('worksheet_set_row')
       worksheet_set_row_opt(LONG worksheet,LONG row,REAL height,LONG format,BYTE options),LONG,RAW,C,NAME('worksheet_set_row_opt')
       worksheet_set_column (LONG worksheet,LONG first_col,LONG last_col,REAL width,LONG format),LONG,RAW,C,NAME('worksheet_set_column')
       worksheet_set_column_opt (LONG worksheet,LONG first_col,LONG last_col,REAL width,LONG format,BYTE options),LONG,RAW,C,NAME('worksheet_set_column_opt')

       worksheet_insert_image(LONG worksheet,LONG row,LONG col,*CSTRING filename),LONG,RAW,C,NAME('worksheet_insert_image')
       worksheet_insert_image_opt(LONG worksheet,LONG row,LONG col,*CSTRING filename,*IMAGEOPTIONS options),LONG,RAW,C,NAME('worksheet_insert_image_opt')

       worksheet_merge_range(LONG worksheet,LONG first_row,LONG first_col,LONG last_row,LONG last_col,<*CSTRING string>,LONG format),LONG,RAW,C,NAME('worksheet_merge_range')
       worksheet_freeze_panes(LONG worksheet,LONG row,LONG col),RAW,C,NAME('worksheet_freeze_panes')
       worksheet_hide_zero(LONG worksheet),RAW,C,NAME('worksheet_hide_zero')
       worksheet_gridlines(LONG worksheet,BYTE option),RAW,C,NAME('worksheet_gridlines')

       format_set_font_size(LONG format,REAL font_size),RAW,C,NAME('format_set_font_size')
       format_set_font_name(LONG format,*CSTRING font_name),RAW,C,NAME('format_set_font_name')
       format_set_font_color(LONG format,LONG color),RAW,C,NAME('format_set_font_color')
       format_set_bold(LONG format),RAW,C,NAME('format_set_bold')
       format_set_italic(LONG format),RAW,C,NAME('format_set_italic')
       format_set_underline(LONG format,BYTE style),RAW,C,NAME('format_set_underline')
       format_set_font_strikeout(LONG format),RAW,C,NAME('format_set_font_strikeout')
       format_set_font_script(LONG format,BYTE style),RAW,C,NAME('format_set_font_script')

       format_set_num_format(LONG format,*CSTRING num_format),RAW,C,NAME('format_set_num_format')
       format_set_num_format_index(LONG format,BYTE index),RAW,C,NAME('format_set_num_format_index')
       format_set_align (LONG format,BYTE alignment),RAW,C,NAME('format_set_align')
       format_set_text_wrap(LONG format),RAW,C,NAME('format_set_text_wrap')
       format_set_rotation(LONG format,SHORT angle),RAW,C,NAME('format_set_rotation')
       format_set_indent(LONG format,BYTE level),RAW,C,NAME('format_set_indent')
       format_set_shrink(LONG format),RAW,C,NAME('format_set_shrink')

       format_set_pattern(LONG format,BYTE index),RAW,C,NAME('format_set_pattern')
       format_set_bg_color(LONG format,LONG color),RAW,C,NAME('format_set_bg_color')
       format_set_fg_color(LONG format,LONG color),RAW,C,NAME('format_set_fg_color')
       format_set_border(LONG format,BYTE style),RAW,C,NAME('format_set_border')
       format_set_bottom(LONG format,BYTE style),RAW,C,NAME('format_set_bottom')
       format_set_top(LONG format,BYTE style),RAW,C,NAME('format_set_top')
       format_set_left(LONG format,BYTE style),RAW,C,NAME('format_set_left')
       format_set_right(LONG format,BYTE style),RAW,C,NAME('format_set_right')
       format_set_border_color(LONG format,LONG color),RAW,C,NAME('format_set_border_color')
       format_set_bottom_color(LONG format,LONG color),RAW,C,NAME('format_set_bottom_color')
       format_set_top_color(LONG format,LONG color),RAW,C,NAME('format_set_top_color')
       format_set_left_color(LONG format,LONG color),RAW,C,NAME('format_set_left_color')
       format_set_right_color(LONG format,LONG color),RAW,C,NAME('format_set_right_color')

       lxw_strerror(LONG error_num),CSTRING,RAW,C,NAME('lxw_strerror')

     END

 END

xlsxwriter.Construct       PROCEDURE
  CODE
    Self.FormatQ &= NEW(FormatQType)
    clear(Self.FormatQ)
COMPILE('***',_TPictureClassPresent_)
    Self.Picture &= NEW(TPictureClass)
***

xlsxwriter.Destruct        PROCEDURE
  CODE
    Free(Self.FormatQ)
    dispose(SELF.FormatQ)
COMPILE('***',_TPictureClassPresent_)
    dispose(Self.picture)
***

xlsxwriter.NewWorkbook       PROCEDURE(STRING Filename_)
  CODE
    SELF.Filename=clip(Filename_)
    SELF.Workbook=workbook_new(SELF.Filename)
    free(SELF.FormatQ)
    clear(SELF.FormatQ)
    self.ClearFormat()
    SELF.ActiveWorksheet=0

xlsxwriter.AddWorksheet      PROCEDURE(STRING Sheetname_)
cstr   &CSTRING
  CODE
    cstr &=new(cstring(len(clip(Sheetname_))*2+1))
    cstr = clip(Sheetname_)
    ConvertCharSet(cstr,0,65001)
    SELF.ActiveWorksheet=workbook_add_worksheet(SELF.Workbook,cstr)
    dispose(cstr)
    return SELF.ActiveWorksheet

xlsxwriter.CloseWorkbook     PROCEDURE()
  CODE
    return workbook_close(SELF.Workbook)

xlsxwriter.WriteNumber     PROCEDURE(LONG row_,LONG col_,REAL number_)
  CODE
    return worksheet_write_number(SELF.ActiveWorksheet,row_-1,col_-1,number_,SELF.ActiveFormat)

xlsxwriter.WriteBoolean    PROCEDURE(LONG row_,LONG col_,SHORT value_)
  CODE
    return worksheet_write_boolean(SELF.ActiveWorksheet,row_-1,col_-1,value_,SELF.ActiveFormat)

xlsxwriter.WriteString     PROCEDURE(LONG row_,LONG col_,STRING string_)
cstr   &CSTRING
  CODE
    cstr &=new(cstring(len(clip(string_))*2+1))
    cstr = clip(string_)
    ConvertCharSet(cstr,0,65001)
    ret#=worksheet_write_string(SELF.ActiveWorksheet,row_-1,col_-1,cstr,SELF.ActiveFormat)
    dispose(cstr)
    return ret#

xlsxwriter.WriteUrl     PROCEDURE(LONG row_,LONG col_,STRING url_)
cstr   &CSTRING
  CODE
    cstr &=new(cstring(len(clip(url_))*2+1))
    cstr = clip(url_)
    ConvertCharSet(cstr,0,65001)
    ret#=worksheet_write_url(SELF.ActiveWorksheet,row_-1,col_-1,cstr,SELF.ActiveFormat)
    dispose(cstr)
    return ret#

xlsxwriter.WriteFormula    PROCEDURE(LONG row_,LONG col_,STRING formula_,<REAL result_>)
cstr   &CSTRING
  CODE
    cstr &=new(cstring(len(clip(formula_))+1))
    cstr = clip(formula_)
    if omitted(5)
      ret#=worksheet_write_formula(SELF.ActiveWorksheet,row_-1,col_-1,cstr,SELF.ActiveFormat)
    else
      ret#=worksheet_write_formula_num(SELF.ActiveWorksheet,row_-1,col_-1,cstr,SELF.ActiveFormat,result_)
    end
    dispose(cstr)
    return ret#

xlsxwriter.WriteBlank     PROCEDURE(LONG row_,LONG col_)
  CODE
    return worksheet_write_blank(SELF.ActiveWorksheet,row_-1,col_-1,SELF.ActiveFormat)

xlsxwriter.WriteDateTime     PROCEDURE(LONG row_,LONG col_,LONG date_,LONG time_)
dt      GROUP(DATETIME)
 END
  CODE
    dt.year=year(date_)
    dt.month=month(date_)
    dt.day=day(date_)
    dt.hour=int((time_-1)/360000)
    dt.min=int((time_-1-dt.hour*360000)/6000)
    dt.sec=int((time_-1-dt.hour*360000-dt.min*6000)/100)
    return worksheet_write_datetime(SELF.ActiveWorksheet,row_-1,col_-1,dt,SELF.ActiveFormat)

xlsxwriter.Merge     PROCEDURE(LONG first_row_,LONG first_col_,LONG last_row_,LONG last_col_)
  CODE
    return worksheet_merge_range(SELF.ActiveWorksheet,first_row_-1,first_col_-1,last_row_-1,last_col_-1,,0)

xlsxwriter.SetColumn      PROCEDURE(LONG first_col_,LONG last_col_,REAL width_)
  CODE
    return worksheet_set_column(SELF.ActiveWorksheet,first_col_-1,last_col_-1,width_,SELF.ActiveFormat)

xlsxwriter.SetRow      PROCEDURE(LONG row_,REAL height_)
  CODE
    return worksheet_set_row(SELF.ActiveWorksheet,row_-1,height_,SELF.ActiveFormat)

xlsxwriter.ClearFormat PROCEDURE
  CODE
    SELF.ActiveFormat=0
    clear(SELF.Format)
    SELF.Format.Color=COLOR:NONE
    SELF.Format.FontColor=COLOR:NONE
    SELF.Format.BorderColor=COLOR:NONE

xlsxwriter.SetFormat PROCEDURE

  CODE
    SELF.FormatQ.FormatG=SELF.Format
    get(SELF.FormatQ,SELF.FormatQ.FormatG)
    if errorcode()
      SELF.FormatQ.FormatG=SELF.Format
      SELF.FormatQ.Ref=workbook_add_format(SELF.workbook)
      add(SELF.FormatQ)

      if clip(SELF.Format.Picture)<>'' and lower(sub(left(SELF.Format.Picture),1,2))<>'@s'

        COMPILE('***',_TPictureClassPresent_)
        pic#=SELF.Picture.TakePicture(SELF.Format.Picture)
        format_set_num_format(SELF.FormatQ.Ref,SELF.Picture.ExcelMask)
        ***

      end

      if SELF.Format.BorderStyle=15
        format_set_border(SELF.FormatQ.Ref,1)
      elsif SELF.Format.BorderStyle
        if BAND(SELF.Format.BorderStyle,XLSX:BorderLeft)>0
          format_set_left(SELF.FormatQ.Ref,1)
        end
        if BAND(SELF.Format.BorderStyle,XLSX:BorderRight)>0
          format_set_right(SELF.FormatQ.Ref,1)
        end
        if BAND(SELF.Format.BorderStyle,XLSX:BorderTop)>0
          format_set_top(SELF.FormatQ.Ref,1)
        end
        if BAND(SELF.Format.BorderStyle,XLSX:BorderBottom)>0
          format_set_bottom(SELF.FormatQ.Ref,1)
        end
      end
      if SELF.Format.BorderColor <> COLOR:NONE
        format_set_border_color(SELF.FormatQ.Ref,RGBColor(SELF.Format.BorderColor))
      end
      if SELF.Format.Color<> COLOR:NONE
        format_set_fg_color(SELF.FormatQ.Ref,RGBColor(SELF.Format.Color))
      end
      if SELF.Format.FontColor<> COLOR:NONE
        format_set_Font_color(SELF.FormatQ.Ref,RGBColor(SELF.Format.FontColor))
      end
      if SELF.Format.FontSize
        format_set_font_size(SELF.FormatQ.Ref,SELF.Format.FontSize)
      end
      if SELF.Format.FontName<>''
        format_set_font_name(SELF.FormatQ.Ref,SELF.Format.FontName)
      end
      if BAND(SELF.Format.FontStyle,font:Bold)=font:Bold
        format_set_bold(SELF.FormatQ.Ref)
      end
      if BAND(SELF.Format.FontStyle,font:Italic)=font:Italic
        format_set_italic(SELF.FormatQ.Ref)
      end
      if BAND(SELF.Format.FontStyle,font:UnderLine)=font:UnderLine
        format_set_underline(SELF.FormatQ.Ref,1)
      end
      if BAND(SELF.Format.FontStyle,font:Strikeout)=font:Strikeout
        format_set_font_strikeout(SELF.FormatQ.Ref)  
      end
      if SELF.Format.Align
        format_set_align(SELF.FormatQ.Ref,SELF.Format.Align)
      end
      if SELF.Format.AlignV
        format_set_align(SELF.FormatQ.Ref,SELF.Format.AlignV)
      end
      if SELF.Format.WrapText
        format_set_text_wrap(SELF.FormatQ.Ref)
      end

    end
    SELF.ActiveFormat=SELF.FormatQ.Ref

xlsxwriter.Gridlines      PROCEDURE(BYTE Option_)
  CODE
    worksheet_gridlines(SELF.ActiveWorksheet,option_)

xlsxwriter.FreezePanes      PROCEDURE(LONG row_,LONG col_)
  CODE
    worksheet_freeze_panes(SELF.ActiveWorksheet,row_-1,col_-1)

xlsxwriter.InsertImage      PROCEDURE(LONG row_,LONG col_,STRING filename_,<*IMAGEOPTIONS options_>)
cstr   &CSTRING
  CODE

    cstr &=new(cstring(len(clip(filename_))*2+1))
    cstr = clip(filename_)
    ConvertCharSet(cstr,0,65001)
    if omitted(5)
      ret#=worksheet_insert_image(SELF.ActiveWorksheet,row_-1,col_-1,cstr)
    else
      ret#=worksheet_insert_image_opt(SELF.ActiveWorksheet,row_-1,col_-1,cstr,options_)
    end
    dispose(cstr)
    return ret#

xlsxwriter.StrError PROCEDURE(LONG error_num)
  CODE
    return lxw_strerror(error_num)

RGBColor             PROCEDURE(LONG color_)
ColorBGR    GROUP,OVER(color_)
B               BYTE
G               BYTE
R               BYTE
C               BYTE
              END

ColorRes   ULONG

  CODE
    color_=GetSystemColor(color_)
    ColorRes = ColorBGR.B
    ColorRes = BShift(ColorRes, 8) + ColorBGR.G
    ColorRes = BShift(ColorRes, 8) + ColorBGR.R
    return ColorRes

GetSystemColor         PROCEDURE(LONG Color)

LOC:Ret    LONG

COLOR_BTNFACE              EQUATE(15)
COLOR_3DDKSHADOW           EQUATE(21)
COLOR_3DFACE               EQUATE(15)
COLOR_3DHILIGHT            EQUATE(20)
COLOR_3DLIGHT              EQUATE(22)
COLOR_3DSHADOW             EQUATE(16)
COLOR_ACTIVEBORDER         EQUATE(10)
COLOR_ACTIVECAPTION        EQUATE(2)
COLOR_APPWORKSPACE         EQUATE(12)
COLOR_BACKGROUND           EQUATE(1)
COLOR_BTNHIGHLIGHT         EQUATE(COLOR_3DHILIGHT)
COLOR_BTNSHADOW            EQUATE(16)
COLOR_BTNTEXT              EQUATE(18)
COLOR_CAPTIONTEXT          EQUATE(9)
COLOR_DESKTOP              EQUATE(1)
COLOR_GRAYTEXT             EQUATE(17)
COLOR_HIGHLIGHT            EQUATE(13)
COLOR_HIGHLIGHTTEXT        EQUATE(14)
COLOR_INACTIVEBORDER       EQUATE(11)
COLOR_INACTIVECAPTION      EQUATE(3)
COLOR_INACTIVECAPTIONTEXT  EQUATE(19)
COLOR_INFOBK               EQUATE(24)
COLOR_INFOTEXT             EQUATE(23)
COLOR_MENU                 EQUATE(4)
COLOR_MENUTEXT             EQUATE(7)
COLOR_SCROLLBAR            EQUATE(0)
COLOR_WINDOW               EQUATE(5)
COLOR_WINDOWFRAME          EQUATE(6)
COLOR_WINDOWTEXT           EQUATE(8)

   CODE
   case color
   of COLOR:SCROLLBAR
     LOC:Ret = GetSysColor(COLOR_SCROLLBAR)
   of COLOR:BACKGROUND
     LOC:Ret = GetSysColor(COLOR_BACKGROUND)
   of COLOR:ACTIVECAPTION
     LOC:Ret = GetSysColor(COLOR_ACTIVECAPTION)
   of COLOR:INACTIVECAPTION
     LOC:Ret = GetSysColor(COLOR_INACTIVECAPTION)
   of COLOR:MENU
     LOC:Ret = GetSysColor(COLOR_MENU)
   of COLOR:WINDOW
     LOC:Ret = GetSysColor(COLOR_WINDOW)
   of COLOR:WINDOWFRAME
     LOC:Ret = GetSysColor(COLOR_WINDOWFRAME)
   of COLOR:MENUTEXT
     LOC:Ret = GetSysColor(COLOR_MENUTEXT)
   of COLOR:WINDOWTEXT
     LOC:Ret = GetSysColor(COLOR_WINDOWTEXT)
   of COLOR:CAPTIONTEXT
     LOC:Ret = GetSysColor(COLOR_CAPTIONTEXT)
   of COLOR:ACTIVEBORDER
     LOC:Ret = GetSysColor(COLOR_ACTIVEBORDER)
   of COLOR:INACTIVEBORDER
     LOC:Ret = GetSysColor(COLOR_INACTIVEBORDER)
   of COLOR:APPWORKSPACE
     LOC:Ret = GetSysColor(COLOR_APPWORKSPACE)
   of COLOR:HIGHLIGHT
     LOC:Ret = GetSysColor(COLOR_HIGHLIGHT)
   of COLOR:HIGHLIGHTTEXT
     LOC:Ret = GetSysColor(COLOR_HIGHLIGHTTEXT)
   of COLOR:BTNFACE
     LOC:Ret = GetSysColor(COLOR_BTNFACE)
   of COLOR:BTNSHADOW
     LOC:Ret = GetSysColor(COLOR_BTNSHADOW)
   of COLOR:GRAYTEXT
     LOC:Ret = GetSysColor(COLOR_GRAYTEXT)
   of COLOR:BTNTEXT
     LOC:Ret = GetSysColor(COLOR_BTNTEXT)
   of COLOR:INACTIVECAPTIONTEXT
     LOC:Ret = GetSysColor(COLOR_INACTIVECAPTIONTEXT)
   of COLOR:BTNHIGHLIGHT
     LOC:Ret = GetSysColor(COLOR_BTNHIGHLIGHT)
   else
     LOC:Ret = Color
   end
   return(LOC:Ret)

ConvertCharSet   PROCEDURE(*cstring Str_In,long in_,long out_)
l           long

strInpChar  &CSTRING
strWideChar &CSTRING
strOutChar  &CSTRING
lenWideChar long
 code

    l = len(clip(str_in))

    strInpChar &= new(CSTRING(l + 1)); strInpChar = all('<0>',l)
    strWideChar &= new(CSTRING(l*2 + 1)); strWideChar = all('<0>',l*2)
    strOutChar &= new(CSTRING(l*2 + 1)); strOutChar = all('<0>',l*2)

    strInpChar = clip(Str_In)
    lenWideChar = MultiByteToWideChar(in_,0,strInpChar,l,strWideChar,l*2)
    res# = WideCharToMultiByte(out_,0,strWideChar,lenWideChar,strOutChar,l*2,0,0)
    Str_In = strOutChar
    strInpChar = all('<0>',l); dispose(strInpChar)
    strWideChar = all('<0>',l*2); dispose(strWideChar)
    strOutChar = all('<0>',l*2); dispose(strOutChar)